/**
 * Titel:     Quelltext zu Kapitel 13 <br />
 * Buch:      Grundkurs-Java fr Wirtschaftsinformatiker. Vieweg 2007. <br />
 * Autoren:   Klaus-Georg Deck und Herbert Neuendorf
 * Copyright: Copyright (c) 2007 <br />
 * 
 * @author Herbert Neuendorf<br />
 * @version 1.0 <br />
 * 
 */
abstract class Konto {    // enthlt eine abstrakte Methode
   	private String name;      	
	private int kontoNr;  
 	private double saldo;
  	public Konto( String n, int kn ) { 
		name = n;   
		kontoNr = kn; 
	}
  	public void setSaldo( double betrag ) { 
		saldo = betrag; 
	}
   	public double getSaldo() { 
		return saldo; 
	}
  	public void einzahlen( double betrag ) { 
		saldo += betrag; 
	}
   	public abstract boolean abheben( double ge );
    // .....
}

class Giro extends Konto {    // konkrete Klasse
   	private double dispo;
  	public Giro( String n, int kn, double dsp ) { 
      	super( n, kn );     
		dispo = dsp; 
  	}
  	public boolean abheben( double betrag ) {
      	double test = getSaldo()-Math.abs(betrag);
		if( test < dispo ) { return false; }  
		else { setSaldo( test );    return true; }  
  	} 
   	// weitere Methoden 
}
   
class Sparkonto extends Konto {    // konkrete Klasse
   	private double zinsSatz;
   	public Sparkonto( String n, int kn, double zs ) { 
         super( n, kn );     
		 zinsSatz = zs; 
  	}
  	public boolean abheben( double betrag ) { 
      	double test = getSaldo() - Math.abs(betrag);
		if( test < 0.0 ) { return false; }
       	else { setSaldo( test );    return true; }
   	}
   	// weitere Methoden
}

public class Bank  {
	public static void main( String[] args ) {
		// ...
	}
}






   


 
 





