/**
 * Titel:     Quelltext zu Kapitel 13 <br />
 * Buch:      Grundkurs-Java fr Wirtschaftsinformatiker. Vieweg 2007. <br />
 * Autoren:   Klaus-Georg Deck und Herbert Neuendorf
 * Copyright: Copyright (c) 2007 <br />
 * 
 * @author Herbert Neuendorf<br />
 * @version 1.0 <br />
 * 
 */
 
abstract class Konto {	   // abstrakte Oberklasse
      private String name;    
	  private int kontoNr;  
      private double saldo;
      public Konto( String n, int kn, double sd ) {
         name = n;    
		 kontoNr = kn;    
		 saldo = sd;
      }
      public void einzahlen( double betrag ) { 
         saldo = saldo + Math.abs(betrag);
      }
      public String getName() { return name; }
      public int getKontoNr() { return kontoNr; }
      public double getSaldo() { return saldo; }
      public void setSaldo( double betrag ) { saldo = betrag; }
	  
      abstract public boolean abheben( double betrag);
      abstract public void zinsen();
}

class Giro extends Konto {
      private double dispo;      
	  private double sollZins;
      private boolean zuHoch;    
	  private boolean ueberzogen;
      private static int zaehlerGiro = 0;
      public Giro( String n, double sd, double disp, double sZ ) {
         super( n, zaehlerGiro+100, sd );
         zaehlerGiro++;
         dispo = -Math.abs(disp);    
		 sollZins = sZ;
      }
      public boolean abheben( double betrag ) {
         double test = getSaldo() - Math.abs(betrag);
         if( test < dispo ) return false;
         else { setSaldo( test );    return true; }
      }
      public void zinsen() {
         if( getSaldo() < 0.0 ) {    // nur Sollzinsen 
            setSaldo( getSaldo()*(1 + sollZins) );
         }
      }
      public String toString() {
         check();
         String daten = "Girokontodaten:\n";
         daten += "Girokontonummer = " + getKontoNr() + "\n";
         daten += "Inhaber = " + getName() + "\n";
         daten += "Dispo = " + dispo + "\n";
         daten += "Kontostand = " + IO.round( getSaldo(),2 ) + "\n";
         daten += "Sollzinssatz = " + sollZins + "\n";
         daten += "berzogen = " + ueberzogen + "\n";
         daten += "Hochstand = " + zuHoch + "\n";
         return daten;
      }
      private void check() {
         ueberzogen = ( getSaldo() < 0.0 );
         zuHoch = ( getSaldo() > 1000.0 ); 
      }
}
   
class Sparkonto extends Konto {
      private double zinsSatz;    
      private static int zaehlerSpar = 0;
      Sparkonto(String n, double sd, double zs) {
         super( n, zaehlerSpar+200, sd );
         zaehlerSpar++;    zinsSatz = zs;
      }
      public boolean abheben( double betrag ) {
         double test = getSaldo() - Math.abs(betrag);
         if (test < 0.0 ) return false;
         else { setSaldo( test );     return true; }
      }
      public void zinsen() { 
	     setSaldo( getSaldo()*(1+zinsSatz) ); 
	  }
      public String toString() {
         String daten = "Sparkontodaten:\n";
         daten += "Sparkontonummer = " + getKontoNr() + "\n";
         daten += "Inhaber = " + getName() + "\n";
         daten += "Kontostand = " + IO.round( getSaldo(), 2) + "\n";
         daten += "Zinsatz = " + zinsSatz + "\n";
         return daten;
      }
}
   
class Festzinskonto extends Sparkonto {
      private int laufzeit;     
	  private int abgelaufeneZeit;
      Festzinskonto( String n, double sd, double zs, int lz ) {
         super( n, sd, zs );
         laufzeit = Math.abs(lz);     
		 abgelaufeneZeit = 0;
      }
      public boolean abheben( double betrag ) {
         if( laufzeit > abgelaufeneZeit ) return false;
         return super.abheben( betrag );
      }
      public String toString() {
         String daten = super.toString();
         daten += "Gesamtlaufzeit = " + laufzeit + "\n";
         daten += "Anlagedauer = " + abgelaufeneZeit + "\n";
         return daten;
      }
      public void zinsen() { 
	  	 super.zinsen();   
		 abgelaufeneZeit++; }
} 
   
public class Bank2 { 
   /* .... */ 
}
   
 









   


 
 





